package com.google.code.p.narcissus.core.model;

import java.util.HashSet;
import java.util.Set;

/**
 * A TestRun is a set of tests.
 * <p>
 * The idea behind this class is to serve as a single root object to manipulate when wanting to perform actions on multiple tests at a time.
 * </p>
 * 
 * @author Jérôme JADOULLE [JADOJ]
 * 
 */
public class TestRun {

	private Set<FaceTest> tests;

	public Set<FaceTest> getTests() {
		return tests;
	}

	public void setTests(Set<FaceTest> tests) {
		this.tests = tests;
	}

	public void addTest(FaceTest test) {
		if (this.tests == null) {
			this.tests = new HashSet<FaceTest>();
		}
		this.tests.add(test);
	}

}
